#include "StdAfx.h"
#include "disctree.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




void CDiscTree::InitCtrl(HWND hWnd, CTreeCtrl& TreeCtrl)
{
	m_hWnd = hWnd;
	m_pTreeCtrl = &TreeCtrl;

	if(!GetSysImgList())	// Get icon image from system
		MessageBox("Failed load system's Icon");
	GetDriveNamesAndRegistration(m_arryDriveName); // Get Drive list and registration
}




BOOL CDiscTree::NewFolder()
{
	if(m_LastSelectedPath== "" || m_SeletedItem == NULL){
		MessageBox("You must select folder");
		return FALSE;
	}

	CString		strSelectedPath = m_LastSelectedPath;
	CString		strTmpPath;
	HTREEITEM	hSelectedItem = m_SeletedItem;
	HTREEITEM	hChild;
	LONG		lCount	= 0;
	BOOL		bMake	= TRUE;
	char		arrCount[255]={0,};

	while(bMake){

		
		strTmpPath = strSelectedPath;
		TRACE(strTmpPath);
		
		memset(arrCount,0,255);
		if(lCount)				//if folder name repetition add (count)
			wsprintf(arrCount, "\\NewFolder (%d)",lCount);
		else
			wsprintf(arrCount, "\\NewFolder");
            
		strTmpPath +=arrCount;
		lCount++;
		TRACE(strTmpPath);

		if(::CreateDirectory(strTmpPath,NULL))
			bMake = FALSE;
		TRACE(strTmpPath);

	}

	hChild = m_pTreeCtrl->GetChildItem(hSelectedItem);
	while ( hChild ){
		m_pTreeCtrl->DeleteItem( hChild );
		hChild = m_pTreeCtrl->GetChildItem(hSelectedItem);
	}  
	DisplayPath(hSelectedItem,m_LastSelectedPath);
	m_pTreeCtrl->Expand(hSelectedItem, TVE_EXPAND);

	return TRUE;
}

BOOL CDiscTree::DeleteFolder()
{
	if(m_LastSelectedPath== "" || m_SeletedItem == NULL){
		MessageBox("You must select folder");
		return FALSE;
	}

	SHFILEOPSTRUCT sfos;
	sfos.hwnd = NULL;
	sfos.wFunc = FO_DELETE;
	sfos.pFrom = m_LastSelectedPath;
	sfos.pTo=NULL;
	sfos.fFlags = FOF_ALLOWUNDO ;
	sfos.fAnyOperationsAborted = FALSE;
	sfos.hNameMappings = NULL ;
	sfos.lpszProgressTitle = "";

	SHFileOperation(&sfos);

	if(sfos.fAnyOperationsAborted != TRUE){
		// Get parents path and item handle
		CString		strParentPath = GetParentPath(m_LastSelectedPath);
		HTREEITEM	hParentItem =  m_pTreeCtrl->GetParentItem(m_SeletedItem);
		HTREEITEM	hChild = m_pTreeCtrl->GetChildItem(hParentItem);

		while ( hChild ){
			m_pTreeCtrl->DeleteItem( hChild );
			hChild = m_pTreeCtrl->GetChildItem(hParentItem);
		}

		DisplayPath(hParentItem,strParentPath);
		m_pTreeCtrl->Expand(m_SeletedItem, TVE_EXPAND);
	}
	return TRUE;

}
BOOL CDiscTree::RenamingFolder(const LPNMTVDISPINFO &pTVDispInfo)
{

	if(m_LastSelectedPath== "" || m_SeletedItem == NULL){
		MessageBox("You must select folder");
		return FALSE;
	}

	CString tmpParentPath = GetParentPath(m_LastSelectedPath);
	CString tmpNewFullPath = tmpParentPath;

	tmpNewFullPath += pTVDispInfo->item.pszText;

	HTREEITEM hChild,hParent;
	hParent = m_pTreeCtrl->GetParentItem(pTVDispInfo->item.hItem);

 	if( ::MoveFile(m_LastSelectedPath,tmpNewFullPath ) )
	{
		hChild  = pTVDispInfo->item.hItem;		
		while ( hChild ){
			m_pTreeCtrl->DeleteItem( hChild );
			hChild = m_pTreeCtrl->GetChildItem(hParent);
		}  

		DisplayPath(hParent,tmpParentPath);
		m_pTreeCtrl->Expand(hParent, TVE_EXPAND);
	}
	return TRUE;
	 
}
//----------------------------------------------------------------------------------------------
void CDiscTree::GetDriveNamesAndRegistration(CStringArray &DriveArray)
{
	LONG lIndex = 0, lTemp = 0;
	BOOL bBreak = TRUE;
	HTREEITEM hItem;

	TCHAR DriveNames[100] = {0, };
	TCHAR DriveTemp[100] = {0, };
	TCHAR *pDriveTemp = NULL;

	// Get All Drive's name
	::GetLogicalDriveStrings(sizeof(DriveNames), DriveNames);

	while(DriveNames[lIndex] || bBreak) {
		if(DriveNames[lIndex]){
			if((DriveNames[lIndex] != '\\') && (DriveNames[lIndex] != '/'))
				DriveTemp[lTemp++] = DriveNames[lIndex];
			bBreak = TRUE;
		}// Each drive saved
		else{
			DriveTemp[lTemp] = '\0';
			
			if(DRIVE_CDROM!=::GetDriveType(DriveTemp)) //exclude ODD
			{
				DriveArray.Add(DriveTemp);
				hItem = AddItem(TVI_ROOT,DriveTemp); 
				if(FindSubFolder(DriveTemp))					// if sub-folder were exist,
					m_pTreeCtrl->InsertItem( "", 0, 0, hItem );	// "dropdown" in order to show Mark 
				
				pDriveTemp = DriveTemp;
				if( !wcscmp((wchar_t*)pDriveTemp, (wchar_t*)"C:")) // ʱ⿡ C̺ ȮŰ
					m_pTreeCtrl->Expand(hItem, TVE_EXPAND);
			}
			bBreak = FALSE;
			lTemp = 0;
		}
		lIndex++;
	}
}
//----------------------------------------------------------------------------------------------
void CDiscTree::DisplayPath(HTREEITEM hParent, CString strPath)
{
	CFileFind	find;
	BOOL		bFind;

	CStringArray strDirArray;

	if ( strPath.Right(1) != "\\" )
		strPath += "\\";
	strPath += "*.*";

	bFind = find.FindFile( strPath );

	while ( bFind )
	{
		bFind = find.FindNextFile();

		// Folder
		if ( find.IsDirectory() && !find.IsDots() && !find.IsHidden() )
			strDirArray.Add( find.GetFilePath() );
	}

	for ( int i = 0; i < strDirArray.GetSize(); i++ )
	{
		HTREEITEM hItem = AddItem( hParent, strDirArray.GetAt(i) );
		if ( FindSubFolder( strDirArray.GetAt(i) ) )	// if sub-folder were exist,
			m_pTreeCtrl->InsertItem( "", 0, 0, hItem ); // "dropdown" in order to show Mark 
	}
}


//----------------------------------------------------------------------------------------------
HTREEITEM CDiscTree::AddItem(HTREEITEM hParent, CString strPath)
{
	SHFILEINFO shFinfo;
	LONG lIcon, lIconSel;

	if ( strPath.Right(1) != '\\' )
		strPath += "\\";

	if ( !SHGetFileInfo( strPath,0,	&shFinfo,sizeof( shFinfo ),	SHGFI_ICON | SHGFI_SMALLICON ) )
	{
		MessageBox("Error Gettting SystemFileInfo!");
		return NULL;
	}

	lIcon = shFinfo.iIcon;

	// we only need the index from the system image list
	DestroyIcon( shFinfo.hIcon );

	if ( !SHGetFileInfo( strPath,0,&shFinfo,sizeof( shFinfo ),SHGFI_ICON | SHGFI_OPENICON |	SHGFI_SMALLICON ) )
	{
		MessageBox("Error Gettting SystemFileInfo!");
		return NULL;
	}

	lIconSel = shFinfo.iIcon;

	// we only need the index of the system image list
	DestroyIcon( shFinfo.hIcon );

	if ( strPath.Right(1) == "\\" )
		strPath.SetAt( strPath.GetLength() - 1, '\0' );

	if ( hParent == TVI_ROOT )
		return  m_pTreeCtrl->InsertItem( strPath, lIcon, lIconSel, hParent );

	return m_pTreeCtrl->InsertItem( GetSubPath( strPath ), lIcon, lIconSel, hParent );
	
}

//----------------------------------------------------------------------------------------------
CString CDiscTree::GetParentPath(CString strPath)
{
	// getting the present SubPath from a ParentPath
	// e.g. C:\temp\readme.txt
	// the result = C:\temp\
	
	LONG lPos, lLengh;

	if ( strPath.Right(1) == '\\' )
		strPath.SetAt( strPath.GetLength() - 1, '\0' );
	
	lPos = strPath.ReverseFind( '\\' );
	
	lLengh = strPath.GetLength();
	
	if ( lPos != -1 ){
		strPath = strPath.Left( lPos + 1);
		//strPath.SetAt( strPath.GetLength() - 1, '\0' );
	}

	return strPath;
}


//----------------------------------------------------------------------------------------------
CString CDiscTree::GetSubPath(CString strPath)
{
	// getting the last SubPath from a PathString
	// e.g. C:\temp\readme.txt
	// the result = readme.txt
	int iPos;

	if ( strPath.Right(1) == '\\' )
		strPath.SetAt( strPath.GetLength() - 1, '\0' );
	iPos = strPath.ReverseFind( '\\' );
	if ( iPos != -1 )
		strPath = strPath.Mid( iPos + 1);

	return strPath;
}
//----------------------------------------------------------------------------------------------
CString CDiscTree::GetFullPath(HTREEITEM hItem)
{
	// get the Full Path of the item
	CString strReturn;
	CString strTemp;
	HTREEITEM hParent = hItem;

	strReturn = "";

	while ( hItem )
	{

		strTemp  = GetItemText( hItem );
		strTemp += "\\";
		strReturn = strTemp + strReturn;
		hItem = GetParentItem( hItem );
	}

	strReturn.TrimRight( '\\' );

	return strReturn;
}



void CDiscTree::ItemExpanding(const NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM	hChild;
	CString		strPath;

	if (pNMTreeView->itemNew.state & TVIS_EXPANDED){
		// Expending Tree
		hChild = m_pTreeCtrl->GetChildItem( pNMTreeView->itemNew.hItem );
		while ( hChild ){
			m_pTreeCtrl->DeleteItem( hChild );
			hChild = m_pTreeCtrl->GetChildItem( pNMTreeView->itemNew.hItem );
		}
		strPath = GetFullPath( pNMTreeView->itemNew.hItem );
		DisplayPath( pNMTreeView->itemNew.hItem, strPath );
	}
	else{	
		// Delete the Items, but leave one there, for expanding the item next time
		hChild = m_pTreeCtrl->GetChildItem( pNMTreeView->itemNew.hItem );
		while ( hChild ){
			m_pTreeCtrl->DeleteItem( hChild );
			hChild = m_pTreeCtrl->GetChildItem( pNMTreeView->itemNew.hItem );
		}
		m_pTreeCtrl->InsertItem( "", pNMTreeView->itemNew.hItem );
	}
}

//----------------------------------------------------------------------------------------------
// Finding SysIconImage
BOOL CDiscTree::GetSysImgList(void)
{
	SHFILEINFO shFinfo;
	HIMAGELIST hImgList = NULL;

	if ( m_pTreeCtrl->GetImageList( TVSIL_NORMAL ) )
		m_ImgList.Detach();

	hImgList = (HIMAGELIST)SHGetFileInfo( "C:\\",
											0,
											&shFinfo,
											sizeof( shFinfo ),
											SHGFI_SYSICONINDEX | SHGFI_SMALLICON );
	if ( !hImgList )
	{
		MessageBox("Cannot retrieve the Handle of SystemImageList!");
		return FALSE;
	}

	m_ImgList.m_hImageList = hImgList;    

	m_pTreeCtrl->SetImageList( &m_ImgList, TVSIL_NORMAL );
	return TRUE;   // OK
}

//----------------------------------------------------------------------------------------------
// Are there Sub-folder ?
BOOL CDiscTree::FindSubFolder(CString strPath)
{
	
	CFileFind	find;
	BOOL		bFind;

	if ( strPath[strPath.GetLength()-1] == '\\' )
		strPath += "*.*";
	else
		strPath += "\\*.*";

	bFind = find.FindFile( strPath );

	while ( bFind )
	{
		bFind = find.FindNextFile();

		if ( find.IsDirectory() && !find.IsDots() && !find.IsHidden() )
		{
			return TRUE;
		}
	}
	return FALSE;
}


